#define EVENTS_BOOTSTRAP() e_bs()

void e_f_create(char *event_id);
void e_f_invoke(char *event_id);
void e_f_addHandler(char *event_id, void *f);
void e_bs(void);

struct e_handlerItem_struct {
	void (*handler)(void);
	struct e_handlerItem_struct *prev;
	struct e_handlerItem_struct *next;
};

struct e_listItem_struct {
	char *event_id;
	struct e_handlerItem_struct *fHandler;
	struct e_handlerItem_struct *lHandler;
	struct e_listItem_struct *next;
	struct e_listItem_struct *prev;
};

struct e_list_struct {
	struct e_listItem_struct *first;
	struct e_listItem_struct *last;
} e_list;

struct e_struct {
	void (* create)(char *);
	void (* invoke)(char *);
	void (* addHandler)(char *, void *);
	struct e_list_struct *rawList;
};

#ifndef EVENTS
#define EPREFIX
#else 
#define EPREFIX extern
#endif


EPREFIX struct e_struct e;