#include <stdio.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdlib.h>

#include "include/webFactory.h"
#include "include/webHandler.h"

void wh_bootstrap() {
	int sock, listener;
	struct sockaddr_in serv_addr = {
		.sin_family = AF_INET,
		.sin_addr = {
			.s_addr = htonl(INADDR_ANY)
		},
		.sin_port = htons(80)
	};

	SOCKET(listener);
    
    if(BIND(listener, serv_addr) < 0) {
    	exit(EXIT_FAILURE);
    }

	LISTEN(listener);

	while(1) {
		sock = accept(listener, (struct sockaddr *)NULL, NULL);
		wf_throwClient(sock);
	}
}